<!-- This component is essentially a single file/url/stream configuration tool.
     It will be used for every endpoint.
-->
<template>
    <div class="border rounded border-gray-400 py-2 px-4 max-h-96">
        <div class="grid grid-cols-2 gap-4">
            <div>
                <div class="mb-2" v-if="title">
                    <label class="font-semibold block">Title</label>
                    <input class="border w-64" v-model="tempConfig.title" />
                </div>
                <div class="mb-2">
                    <label class="font-semibold block">Item Type</label>
                    <slide-dropdown :value="fileType" @input="fileTypeChanged" :options="fileTypeOptions" color="blue">Select Item Type</slide-dropdown>
                </div>
                <div v-if="fileType == 'int'">
                    <label class="font-semibold block">File</label>
                    <file-picker @change="updateMainFile" :filename="fileName">Select Main Item</file-picker>
                </div>
                <div v-else-if="fileType == 'website' || fileType == 'stream'" @change="updateUrl">
                    URL: <input v-model="tempConfig.path" class="border rounded my-2 w-8/12" />
                </div>
                <div v-else-if="fileType == 'show'">
                    <show-picker @change="updateMainShow" :name="showName">Select Show</show-picker>
                </div>
                <div v-if="fileType == 'website'">
                    <alert color="yellow"> For a website to be offline, it must be secure (HTTPS).</alert>
                </div>
                <div v-if="fileType == 'stream'">
                    Stream Type:    
                    <slide-dropdown :value="tempConfig.format" @input="format => {tempConfig.format = format}" :options="streamTypeOptions" color="blue">
                        Select Stream Type
                    </slide-dropdown>
                    <alert color="yellow"> Streaming is an online-only function.</alert>
                </div>
                <div class="mt-2" v-if="tempConfig.format.startsWith('image/')">
                    Background Color: <input type="color" v-model="tempConfig.backgroundColor" class="border rounded-sm">
                </div>
                <div v-if="tempConfig.format.startsWith('video/') && !dependent" class="py-2">
                    <label class="font-semibold block">Interaction</label>
                    <slide-dropdown :value="tempConfig.interaction" :options="interactionOptions" @input="(value)=>{tempConfig.interaction = value}" color="blue">
                        Interaction
                    </slide-dropdown>
                    <div v-if="tempConfig.interaction == 'tap'" >
                        Front image:
                        <file-picker @change="updateVideoOptionImage" filter="image"/>
                        It is best to say something about "tap here to play", as the image wil be displayed without any text added.
                    </div>
                </div>
            </div>
            <div class="flex justify-center content-center items-center">
                <!-- This should always be in-sync with the client's Single component -->
                <video v-if="tempConfig.format.startsWith('video/')" class="w-full" :src="'/files/' + tempConfig.path + '?raw'" controls /><!-- change to videoplayer -->
                <video v-else-if="tempConfig.format == 'stream'" class="w-full" controls>
                    <source :src="tempConfig.path" :type="tempConfig.type" />
                </video>
                <div v-else-if="tempConfig.format.startsWith('image/')" class="flex w-full h-full text-center items-center justify-center" :style="{'background-color':tempConfig.backgroundColor}">
                    <img class="max-w-full h-56" :src="'/files/' + tempConfig.path + '?raw'" /><!-- Change to imageviewer-->
                </div>
                <embed v-else-if="tempConfig.format == 'application/pdf'" class="w-full" :src="'/files/' + tempConfig.path + '#toolbar=0&navpanes=0?raw'" :type="tempConfig.format" />
                <iframe v-else-if="tempConfig.format == 'url'" class="w-full" :src="tempConfig.path" /><!-- need auto reset -->
                <div v-else-if="tempConfig.format == ''" class="text-red-500 text-center mx-auto">No Content Selected</div>
                <div v-else class="text-red-500 text-center mx-auto font-semibold">Selected Content not Supported</div>
            </div>
        </div>
    </div>
</template>

<script>
import FilePicker from './FilePicker'
import SlideDropdown from './SlideDropdown'
import Alert from './Alert'
import Vue from 'vue'

export default {
    name: 'ItemConfigurator',
    components: {
        FilePicker,
        Alert,
        SlideDropdown,
    },
    props: {
        config: {
            type: Object,
            required: true,
        },
        dependent: {
            type: Boolean,
            default: false,
        },
        title: {
            type: Boolean,
            default: false,
        },
        filenames: Object,
    },
    data(){
        let fileType = "int";
        let fileName = "None";
        let showName = "None";
        let tapCoverName = "None";
        const tempConfig = this.config;
        if(!('format' in tempConfig)) tempConfig.format = '';
        if('format' in tempConfig){
            if(tempConfig.format === null || tempConfig.format === "") fileType = '';
            else if(tempConfig.format == 'url') fileType = 'website';
            else if(["application/vnd.apple.mpegurl","application/x-mpegURL"].includes(tempConfig.format)){
                fileType = 'stream';
            } 
        }
        if('path' in tempConfig && tempConfig.path != '' && (fileType == 'int' || fileType == 'show')) fileName = this.filenames[tempConfig.path];
        if(fileType.startsWith('video/') && tempConfig.interaction == 'tap' && tempConfig.tapCoverName != "") tapCoverName = this.filenames[tempConfig.tapCoverName];
        const fileTypeOptions = [
            {
                value: "int",
                label: "Uploaded File",
                feather: 'upload-cloud',
            },
            {
                value: "website",
                label: "External Website",
                feather: 'globe',
            },
            {
                value: "stream",
                label: "External Stream",
                feather: 'airplay',
            },
        ];
        if(this.dependent) fileTypeOptions.splice(1,0,{
            value: "show",
            label: "Another Show",
        });
        return {
            tempConfig,
            fileName,
            fileType,
            fileTypeOptions,
            showName,
            tapCoverName,
            streamTypeOptions: [
                {
                    value: "application/vnd.apple.mpegurl",
                    label: "Apple HLS",
                },
                {
                    value: "application/x-mpegURL",
                    label: "MPEG DASH",
                },
            ],
            interactionOptions: [ 
                {
                    value: 'controls',
                    label: 'Manual Controls',
                    feather: 'play',
                },
                {
                    value: 'autoplay',
                    label: 'Autoplay Loop',
                    feather: 'repeat',
                },
                {
                    value: 'tap',
                    label: 'Tap-n-Play',
                    feather: 'target',
                },
            ]
        }
    },
    methods: {
        fileTypeChanged(type){
            if(type == 'int') {
                this.tempConfig = {
                    path: "",
                    format: "",
                };
                this.fileName = "None";
            } else if (type == 'website') {
                this.tempConfig = {
                    path: "https://",
                    format: "url",
                };
            } else if (type == 'stream') {
                this.tempConfig = {
                    path: "https://",
                    format: "application/vnd.apple.mpegurl",
                };
            } else if (type == 'show') {
                this.tempConfig = {
                    id: null,
                    format: "show",
                };
                this.fileName = "None";
            } else {
                alert("File type invalid");
                return;
            }
            this.fileType = type;
        },
        updateMainFile(fileInfo){
            this.fileName = fileInfo.prettypath;
            Vue.set(this.tempConfig, 'path', fileInfo.path);
            Vue.set(this.tempConfig, 'format', fileInfo.format);
            if(fileInfo.format.startsWith('image/')) Vue.set(this.tempConfig, 'backgroundColor','#000000');
            else Vue.delete(this.tempConfig, 'backgroundColor');
            if(fileInfo.format.startsWith('video/')) Vue.set(this.tempConfig, 'interaction','autoplay');
            else Vue.delete(this.tempConfig, 'interaction');
        },
        updateMainShow(showInfo){
            this.showName = showInfo.name;
            Vue.set(this.tempConfig, 'path', showInfo.id);
            Vue.set(this.tempConfig, 'format', 'show');
        },
        updateUrl(){
            Vue.set(this.tempConfig, 'path', this.urlInput);
            if(this.fileType == 'stream'){
                Vue.set(this.tempConfig, 'format', this.streamFormat);
            } else if(this.fileType == 'website'){
                Vue.set(this.tempConfig, 'format', 'url');
            }
            this.fileName = "None";
        },
        updateVideoOption(){

        },
        updateVideoOptionImage(fileInfo){
            this.tapCoverName = fileInfo.prettypath;
            Vue.set(this.tempConfig, 'tapImage', fileInfo.path);
        }
    },
    watch: {
        tempConfig: {
            handler(){
                this.$emit('change',this.tempConfig);
            },
            deep: true,
        },
    },
    
}
</script>
